'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-582bef72.js');
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
var PropTypes__default = _interopDefault(PropTypes);
var styledTools = require('styled-tools');
var styled = require('./styled.js');
var as = require('./as.js');
var Box = require('./Box.js');
require('styled-components');
require('@emotion/is-prop-valid');
require('hoist-non-react-statics');
require('./chunk-734f0acc.js');
require('./chunk-f0c301b2.js');

var Component = function Component(props) {
  if (props.block) {
    return React__default.createElement(Box.default, __chunk_1._extends({
      as: "pre"
    }, props), React__default.createElement("code", {
      className: props.codeClassName
    }, props.children));
  }

  var className = props.codeClassName ? (props.className + " " + props.codeClassName).trim() : ("" + props.className).trim();
  return React__default.createElement(Box.default, __chunk_1._extends({
    as: "code"
  }, props, {
    className: className
  }));
};

var Code = styled.default(Box.default).withConfig({
  displayName: "Code",
  componentId: "lzotsr-0"
})(["", ";"], styledTools.theme("Code"));
Code.propTypes = {
  block: PropTypes__default.bool,
  codeClassName: PropTypes__default.string
};
Code.defaultProps = {
  opaque: true,
  palette: "background",
  tone: -2
};
var Code$1 = as.default(Component)(Code);

exports.default = Code$1;
