'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styledTools = require('styled-tools');
var styled = require('./styled.js');
var as = require('./as.js');
var Box = require('./Box.js');
var PropTypes = require('prop-types');
var PropTypes__default = _interopDefault(PropTypes);
require('styled-components');
require('./chunk-582bef72.js');
require('@emotion/is-prop-valid');
require('react');
require('hoist-non-react-statics');
require('./chunk-734f0acc.js');
require('./chunk-f0c301b2.js');

var GroupItem = styled.default(Box.default).withConfig({
  displayName: "GroupItem",
  componentId: "kbprqg-0"
})(["", ";"], styledTools.theme("GroupItem"));
var GroupItem$1 = as.default("div")(GroupItem);

var verticalAt = function verticalAt(pass, fail) {
  return styledTools.ifProp("verticalAt", styled.css(["@media (min-width:", "px){", ";}@media (max-width:", "px){", ";}"], styledTools.withProp("verticalAt", function (x) {
    return x + 1;
  }), fail, styledTools.prop("verticalAt"), pass), fail);
};

var Group = styled.default(Box.default).withConfig({
  displayName: "Group",
  componentId: "ope6r0-0"
})(["display:flex;flex-direction:", ";", ";> *:not(:first-child):not(:last-child),> *:not(:first-child):not(:last-child) ", "{border-radius:0;", ";}> *:first-child,> *:first-child ", "{border-bottom-right-radius:0;", ";}> *:last-child,> *:last-child ", "{border-top-left-radius:0;", ";}", ";"], styledTools.ifProp("vertical", "column", "row"), verticalAt("flex-direction: column"), GroupItem$1, verticalAt(styled.css(["border-top-width:0;"]), styled.css(["border-", "-width:0;"], styledTools.ifProp("vertical", "top", "left"))), GroupItem$1, verticalAt(styled.css(["border-bottom-left-radius:0;"]), styled.css(["border-", "-radius:0;"], styledTools.ifProp("vertical", "bottom-left", "top-right"))), GroupItem$1, verticalAt(styled.css(["border-top-width:0;border-top-right-radius:0;"]), styled.css(["border-", "-width:0;border-", "-radius:0;"], styledTools.ifProp("vertical", "top", "left"), styledTools.ifProp("vertical", "top-right", "bottom-left"))), styledTools.theme("Group"));
Group.propTypes = {
  vertical: PropTypes__default.bool,
  verticalAt: PropTypes__default.number
};
Group.defaultProps = {
  role: "group"
};
var Group$1 = as.default("div")(Group);

Group$1.Item = GroupItem$1;

exports.default = Group$1;
