'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-582bef72.js');
var React = require('react');
var React__default = _interopDefault(React);
var ReactDOM = require('react-dom');
var PropTypes = require('prop-types');
var PropTypes__default = _interopDefault(PropTypes);
var styledTools = require('styled-tools');
var Popper = _interopDefault(require('popper.js'));
var styled = require('./styled.js');
var as = require('./as.js');
var Hidden = require('./Hidden.js');
var __chunk_8 = require('./chunk-f8004a06.js');
var __chunk_4 = require('./chunk-25591e69.js');
var __chunk_5 = require('./chunk-e6b983b8.js');
var __chunk_6 = require('./chunk-c3011684.js');
require('styled-components');
require('@emotion/is-prop-valid');
require('hoist-non-react-statics');
require('./chunk-734f0acc.js');
require('./chunk-f0c301b2.js');
require('./Box.js');
require('constate');

var Component =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(Component, _React$Component);

  function Component() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "state", {
      placement: _this.props.placement,
      translateX: undefined,
      translateY: undefined,
      originX: undefined,
      originY: undefined
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "getPopover", function () {
      return ReactDOM.findDOMNode(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)));
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "modifier", function (data) {
      var placement = data.placement,
          offsets = data.offsets,
          arrowElement = data.arrowElement,
          arrowStyles = data.arrowStyles;
      var reference = offsets.reference,
          popper = offsets.popper;

      var _placement$split = placement.split("-"),
          position = _placement$split[0];

      var isVertical = ["top", "bottom"].indexOf(position) >= 0;
      var referenceCenter = isVertical ? reference.width / 2 : reference.height / 2;
      var side = isVertical ? "left" : "top";
      var sideValue = referenceCenter - popper[side];

      if (arrowElement) {
        var top = arrowStyles.top,
            left = arrowStyles.left;
        arrowElement.style.top = isVertical ? "" : top + "px";
        arrowElement.style.left = isVertical ? left + "px" : "";
      }

      _this.setState({
        originX: isVertical ? sideValue + "px - 50%" : 0,
        originY: !isVertical ? sideValue + "px - 50%" : 0,
        translateX: popper.left,
        translateY: popper.top,
        placement: data.placement
      });

      return data;
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "getOptions", function () {
      var _this$props = _this.props,
          placement = _this$props.placement,
          flip = _this$props.flip,
          shift = _this$props.shift;

      var popover = _this.getPopover();

      var arrowClassName = "." + __chunk_8.PopoverArrow.styledComponentId;
      var arrow = popover.querySelector(arrowClassName);
      return {
        placement: placement,
        modifiers: {
          hide: {
            enabled: false
          },
          applyStyle: {
            enabled: false
          },
          arrow: {
            enabled: !!arrow,
            element: arrow
          },
          flip: {
            enabled: flip,
            padding: 16
          },
          shift: {
            enabled: shift
          },
          offset: {
            offset: "0, " + _this.props.gutter
          },
          setState: {
            enabled: true,
            order: 900,
            fn: _this.modifier
          }
        }
      };
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "initPopper", function () {
      if (!_this.popper) {
        var popover = _this.getPopover();

        _this.popper = new Popper(popover.parentNode, popover, _this.getOptions());
      }
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "destroyPopper", function () {
      if (_this.popper) {
        _this.popper.destroy();

        _this.popper = undefined;
      }
    });

    return _this;
  }

  var _proto = Component.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.initPopper();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.destroyPopper();
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (prevProps.visible !== this.props.visible || prevProps.placement !== this.props.placement || prevProps.children !== this.props.children) {
      this.destroyPopper();
      this.initPopper();
    }
  };

  _proto.render = function render() {
    return React__default.createElement(Hidden.default, __chunk_1._extends({
      id: this.props.popoverId
    }, this.state, {
      "data-placement": this.state.placement,
      defaultSlide: this.state.placement.replace(/-.+$/, ""),
      defaultExpand: this.state.placement.replace(/-.+$/, ""),
      slideOffset: this.props.gutter
    }, this.props, {
      unmount: false
    }));
  };

  return Component;
}(React__default.Component);

var Popover = styled.default(Component).withConfig({
  displayName: "Popover",
  componentId: "zeqjxj-0"
})(["position:absolute;top:0;left:0;user-select:auto;cursor:auto;z-index:999;will-change:transform;", ";"], styledTools.theme("Popover"));
Popover.propTypes = {
  placement: PropTypes__default.oneOf(["auto", "top", "right", "bottom", "left", "top-start", "right-start", "bottom-start", "left-start", "top-end", "right-end", "bottom-end", "left-end"]),
  flip: PropTypes__default.bool,
  shift: PropTypes__default.bool,
  gutter: PropTypes__default.oneOfType([PropTypes__default.number, PropTypes__default.string]),
  popoverId: PropTypes__default.string
};
Popover.defaultProps = {
  role: "group",
  placement: "bottom",
  hideOnEsc: true,
  flip: true,
  shift: true,
  gutter: 12,
  opaque: true,
  palette: "white"
};
var Popover$1 = as.default("div")(Popover);

var id = -1;

var uniqueId = function uniqueId(prefix) {
  id += 1;
  return prefix ? "" + prefix + id : id;
};

var onMount = function onMount(_ref) {
  var setState = _ref.setState;
  setState({
    popoverId: uniqueId("popover")
  });
};

var PopoverContainer = function PopoverContainer(props) {
  return React__default.createElement(__chunk_5.HiddenContainer, __chunk_1._extends({}, props, {
    onMount: __chunk_4.callAll(onMount, props.onMount)
  }));
};

var Component$1 = function Component(props) {
  return React__default.createElement(__chunk_6.HiddenToggle, __chunk_1._extends({
    "aria-expanded": props.visible,
    "aria-controls": props.popoverId,
    "aria-haspopup": true
  }, props));
};

var PopoverToggle = styled.default(Component$1).withConfig({
  displayName: "PopoverToggle",
  componentId: "x0s51c-0"
})(["", ";"], styledTools.theme("PopoverToggle"));
PopoverToggle.propTypes = {
  popoverId: PropTypes__default.string,
  visible: PropTypes__default.bool
};
var PopoverToggle$1 = as.default("button")(PopoverToggle);

var Component$2 = function Component(props) {
  return React__default.createElement(__chunk_6.HiddenShow, __chunk_1._extends({
    "aria-expanded": props.visible,
    "aria-controls": props.popoverId,
    "aria-haspopup": true
  }, props));
};

var PopoverShow = styled.default(Component$2).withConfig({
  displayName: "PopoverShow",
  componentId: "hnl7om-0"
})(["", ";"], styledTools.theme("PopoverShow"));
PopoverShow.propTypes = {
  popoverId: PropTypes__default.string,
  visible: PropTypes__default.bool
};
var PopoverShow$1 = as.default("button")(PopoverShow);

var Component$3 = function Component(props) {
  return React__default.createElement(__chunk_6.HiddenHide, __chunk_1._extends({
    "aria-expanded": props.visible,
    "aria-controls": props.popoverId,
    "aria-haspopup": true
  }, props));
};

var PopoverHide = styled.default(Component$3).withConfig({
  displayName: "PopoverHide",
  componentId: "sc-1ogem6j-0"
})(["", ";"], styledTools.theme("PopoverHide"));
PopoverHide.propTypes = {
  popoverId: PropTypes__default.string,
  visible: PropTypes__default.bool
};
var PopoverHide$1 = as.default("button")(PopoverHide);

Popover$1.Arrow = __chunk_8.PopoverArrow;
Popover$1.Container = PopoverContainer;
Popover$1.Toggle = PopoverToggle$1;
Popover$1.Show = PopoverShow$1;
Popover$1.Hide = PopoverHide$1;

exports.default = Popover$1;
