'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-582bef72.js');
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
var PropTypes__default = _interopDefault(PropTypes);
var styledTools = require('styled-tools');
var hoistNonReactStatics = _interopDefault(require('hoist-non-react-statics'));
var styled = require('./styled.js');
var as = require('./as.js');
var Hidden = require('./Hidden.js');
var __chunk_6 = require('./chunk-c3011684.js');
var __chunk_9 = require('./chunk-70e063af.js');
require('styled-components');
require('@emotion/is-prop-valid');
require('react-dom');
require('./chunk-734f0acc.js');
require('./chunk-f0c301b2.js');
require('./chunk-25591e69.js');
require('./Box.js');
require('./chunk-e6b983b8.js');
require('constate');

var noop = function noop() {
  return false;
};

var Component =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(Component, _React$Component);

  function Component(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    var _this$props = _this.props,
        register = _this$props.register,
        step = _this$props.step,
        order = _this$props.order;
    register(step, order);
    return _this;
  }

  var _proto = Component.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _this$props2 = this.props,
        step = _this$props2.step,
        update = _this$props2.update,
        order = _this$props2.order;

    if (prevProps.step !== step || prevProps.order !== order) {
      update(prevProps.step, step, order);
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    var _this$props3 = this.props,
        step = _this$props3.step,
        unregister = _this$props3.unregister;
    unregister(step);
  };

  _proto.render = function render() {
    var _this$props4 = this.props,
        isCurrent = _this$props4.isCurrent,
        step = _this$props4.step;
    return React__default.createElement(Hidden.default, __chunk_1._extends({
      unmount: true,
      visible: isCurrent(step)
    }, this.props));
  };

  return Component;
}(React__default.Component);

hoistNonReactStatics(Component, Hidden.default);
var Step = styled.default(Component).withConfig({
  displayName: "Step",
  componentId: "sc-13njvly-0"
})(["", ";"], styledTools.theme("Step"));
Step.propTypes = {
  step: PropTypes__default.string.isRequired,
  register: PropTypes__default.func.isRequired,
  update: PropTypes__default.func.isRequired,
  unregister: PropTypes__default.func.isRequired,
  isCurrent: PropTypes__default.func.isRequired,
  order: PropTypes__default.number
};
Step.defaultProps = {
  register: noop,
  update: noop,
  unregister: noop,
  isCurrent: noop
};
var Step$1 = as.default("div")(Step);

var toggle = function toggle(props) {
  return function () {
    return props.toggle && props.toggle(props.step);
  };
};

var Component$1 = function Component(props) {
  return React__default.createElement(__chunk_6.HiddenToggle, __chunk_1._extends({}, props, {
    toggle: toggle(props)
  }));
};

var StepToggle = styled.default(Component$1).withConfig({
  displayName: "StepToggle",
  componentId: "oour1d-0"
})(["", ";"], styledTools.theme("StepToggle"));
StepToggle.propTypes = {
  toggle: PropTypes__default.func.isRequired,
  step: PropTypes__default.string.isRequired
};
var StepToggle$1 = as.default("button")(StepToggle);

var show = function show(props) {
  return function () {
    return props.show && props.show(props.step);
  };
};

var Component$2 = function Component(props) {
  return React__default.createElement(__chunk_6.HiddenShow, __chunk_1._extends({}, props, {
    show: show(props)
  }));
};

var StepShow = styled.default(Component$2).withConfig({
  displayName: "StepShow",
  componentId: "sc-1eog66r-0"
})(["", ";"], styledTools.theme("StepShow"));
StepShow.propTypes = {
  show: PropTypes__default.func.isRequired,
  step: PropTypes__default.string.isRequired
};
var StepShow$1 = as.default("button")(StepShow);

var StepHide = styled.default(__chunk_6.HiddenHide).withConfig({
  displayName: "StepHide",
  componentId: "sc-1523whe-0"
})(["", ";"], styledTools.theme("StepHide"));
var StepHide$1 = as.default("button")(StepHide);

Step$1.Container = __chunk_9.StepContainer;
Step$1.Toggle = StepToggle$1;
Step$1.Show = StepShow$1;
Step$1.Hide = StepHide$1;
Step$1.Next = __chunk_9.StepNext;
Step$1.Previous = __chunk_9.StepPrevious;

exports.default = Step$1;
