'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styledTools = require('styled-tools');
var styled = require('./styled.js');
var as = require('./as.js');
var Box = require('./Box.js');
var __chunk_1 = require('./chunk-582bef72.js');
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
var PropTypes__default = _interopDefault(PropTypes);
var __chunk_9 = require('./chunk-70e063af.js');
var __chunk_4 = require('./chunk-25591e69.js');
var Step = require('./Step.js');
var hoistNonReactStatics = _interopDefault(require('hoist-non-react-statics'));
var Hidden = require('./Hidden.js');
require('styled-components');
require('@emotion/is-prop-valid');
require('./chunk-734f0acc.js');
require('./chunk-f0c301b2.js');
require('constate');
require('./chunk-c3011684.js');
require('react-dom');
require('./chunk-e6b983b8.js');

var Tabs = styled.default(Box.default).withConfig({
  displayName: "Tabs",
  componentId: "sc-13wu9lo-0"
})(["", ";"], styledTools.theme("Tabs"));
Tabs.defaultProps = {
  role: "tablist"
};
var Tabs$1 = as.default("ul")(Tabs);

var initialState = {
  loop: true,
  current: 0
}; // istanbul ignore next

var TabsContainer = function TabsContainer(props) {
  return React__default.createElement(__chunk_9.StepContainer, __chunk_1._extends({}, props, {
    initialState: __chunk_1._objectSpread({}, initialState, props.initialState)
  }));
};

TabsContainer.propTypes = {
  initialState: PropTypes__default.object
};

/* eslint-disable no-param-reassign */
var createElementRef = function createElementRef(scope, property) {
  return function (element) {
    scope[property] = element;

    if (scope.props && scope.props.elementRef) {
      scope.props.elementRef(element);
    }
  };
};

var Component =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inheritsLoose(Component, _React$Component);

  function Component() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "element", undefined);

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "show", function () {
      var _this$props = _this.props,
          show = _this$props.show,
          isCurrent = _this$props.isCurrent,
          tab = _this$props.tab;

      if (!isCurrent(tab)) {
        show(tab);
      }
    });

    __chunk_1._defineProperty(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)), "keyDown", function (e) {
      var keyMap = {
        ArrowLeft: _this.props.previous,
        ArrowRight: _this.props.next
      };

      if (keyMap[e.key]) {
        e.preventDefault();
        keyMap[e.key]();
      }
    });

    return _this;
  }

  var _proto = Component.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _this$props2 = this.props,
        current = _this$props2.current,
        isCurrent = _this$props2.isCurrent,
        tab = _this$props2.tab;

    if (prevProps.current !== current && isCurrent(tab) && this.element) {
      this.element.focus();
    }
  };

  _proto.render = function render() {
    var _this$props3 = this.props,
        isCurrent = _this$props3.isCurrent,
        tab = _this$props3.tab,
        className = _this$props3.className,
        onClick = _this$props3.onClick,
        onFocus = _this$props3.onFocus,
        onKeyDown = _this$props3.onKeyDown;
    var active = isCurrent(tab);
    var activeClassName = active ? "active" : "";
    var finalClassName = [className, activeClassName].filter(Boolean).join(" ");
    return React__default.createElement(Step.default, __chunk_1._extends({
      id: tab + "Tab",
      step: tab,
      active: active,
      "aria-selected": active,
      "aria-controls": tab + "Panel",
      tabIndex: active ? 0 : -1,
      visible: true
    }, this.props, {
      onClick: __chunk_4.callAll(this.show, onClick),
      onFocus: __chunk_4.callAll(this.show, onFocus),
      onKeyDown: __chunk_4.callAll(this.keyDown, onKeyDown),
      className: finalClassName,
      elementRef: createElementRef(this, "element")
    }));
  };

  return Component;
}(React__default.Component);

var TabsTab = styled.default(Component).withConfig({
  displayName: "TabsTab",
  componentId: "sc-1eltiq9-0"
})(["", ";"], styledTools.theme("TabsTab"));
TabsTab.propTypes = {
  tab: PropTypes__default.string.isRequired,
  register: PropTypes__default.func.isRequired,
  update: PropTypes__default.func.isRequired,
  unregister: PropTypes__default.func.isRequired,
  isCurrent: PropTypes__default.func.isRequired,
  show: PropTypes__default.func.isRequired,
  next: PropTypes__default.func.isRequired,
  previous: PropTypes__default.func.isRequired,
  className: PropTypes__default.string,
  disabled: PropTypes__default.bool,
  onClick: PropTypes__default.func,
  onFocus: PropTypes__default.func,
  onKeyDown: PropTypes__default.func
};

var noop = function noop() {};

TabsTab.defaultProps = {
  role: "tab",
  register: noop,
  update: noop,
  unregister: noop,
  isCurrent: noop,
  show: noop,
  next: noop,
  previous: noop
};
var TabsTab$1 = as.default("li")(TabsTab);

var Component$1 = function Component(props) {
  var isCurrent = props.isCurrent,
      tab = props.tab;
  return React__default.createElement(Hidden.default, __chunk_1._extends({
    id: tab + "Panel",
    "aria-labelledby": tab + "Tab",
    unmount: true,
    visible: isCurrent && isCurrent(tab)
  }, props));
};

hoistNonReactStatics(Component$1, Hidden.default);
var TabsPanel = styled.default(Component$1).withConfig({
  displayName: "TabsPanel",
  componentId: "sc-1iv81zv-0"
})(["", ";"], styledTools.theme("TabsPanel"));
TabsPanel.propTypes = {
  tab: PropTypes__default.string.isRequired,
  isCurrent: PropTypes__default.func.isRequired
};
TabsPanel.defaultProps = {
  role: "tabpanel"
};
var TabsPanel$1 = as.default("div")(TabsPanel);

var TabsNext = styled.default(__chunk_9.StepNext).withConfig({
  displayName: "TabsNext",
  componentId: "sc-1tm3dzq-0"
})(["", ";"], styledTools.theme("TabsNext"));
var TabsNext$1 = as.default("button")(TabsNext);

var TabsPrevious = styled.default(__chunk_9.StepPrevious).withConfig({
  displayName: "TabsPrevious",
  componentId: "sc-2s0xw8-0"
})(["", ";"], styledTools.theme("TabsPrevious"));
var TabsPrevious$1 = as.default("button")(TabsPrevious);

Tabs$1.Container = TabsContainer;
Tabs$1.Tab = TabsTab$1;
Tabs$1.Panel = TabsPanel$1;
Tabs$1.Next = TabsNext$1;
Tabs$1.Previous = TabsPrevious$1;

exports.default = Tabs$1;
