'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var __chunk_1 = require('./chunk-582bef72.js');
var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = require('prop-types');
var PropTypes__default = _interopDefault(PropTypes);
var constate = require('constate');

var initialState = {
  visible: false
};
var show = function show() {
  return function () {
    return {
      visible: true
    };
  };
};
var hide = function hide() {
  return function () {
    return {
      visible: false
    };
  };
};
var toggle = function toggle() {
  return function (state) {
    return {
      visible: !state.visible
    };
  };
};
var actions = {
  show: show,
  hide: hide,
  toggle: toggle
};

var HiddenContainer = function HiddenContainer(props) {
  return React.createElement(constate.Container, __chunk_1._extends({}, props, {
    initialState: __chunk_1._objectSpread({}, initialState, props.initialState),
    actions: actions
  }));
}; // @ts-ignore


HiddenContainer.propTypes = {
  initialState: PropTypes.object,
  actions: PropTypes.objectOf(PropTypes.func)
};

exports.HiddenContainer = HiddenContainer;
