import * as React from "react";
import CSSProps from "./_utils/CSSProps";
declare type Omit<T, K extends keyof T> = Pick<T, Exclude<keyof T, K>>;
export declare type CSSProperties = {
    [key in keyof typeof CSSProps]?: string | number;
};
export declare type AllProps<T = any> = Omit<React.HTMLProps<T>, "as"> & ReakitProps<T> & CSSProperties;
export declare type SingleAsProp = keyof JSX.IntrinsicElements | React.ComponentType<AllProps>;
export declare type AsProp = SingleAsProp | SingleAsProp[];
export interface ReakitProps<T = any> {
    as?: AsProp | null;
    nextAs?: SingleAsProp | null;
    elementRef?: React.Ref<T>;
}
export declare type ReakitComponent<P extends AllProps = object> = React.ComponentType<P> & {
    asComponents: AsProp;
    as: (asComponents: AsProp) => ReakitComponent<P>;
};
declare type AllPropsReplaceAs<P extends AllProps> = Omit<P, "as"> & AllProps;
declare function as(asComponents: AsProp): <P extends AllProps<any>>(WrappedComponent: React.ComponentType<P>) => ReakitComponent<AllPropsReplaceAs<P>>;
export default as;
